? slime-repl-indent-fix.diff
Index: slime.el
===================================================================
RCS file: /project/slime/cvsroot/slime/slime.el,v
retrieving revision 1.314
diff -u -r1.314 slime.el
--- slime.el	16 Jun 2004 00:13:42 -0000	1.314
+++ slime.el	16 Jun 2004 07:04:59 -0000
@@ -5812,7 +5812,9 @@
         (fill-paragraph nil)
       (let ((start (progn (unless (and (zerop (current-column))
                                        (eq ?\( (char-after)))
-                            (beginning-of-defun))
+                            (if slime-repl-input-start-mark
+                                (slime-repl-beginning-of-defun)
+                              (beginning-of-defun)))
                           (point)))
             (end (ignore-errors (end-of-defun) (point))))
         (unless end