Index: slime.el
===================================================================
RCS file: /project/slime/cvsroot/slime/slime.el,v
retrieving revision 1.312
diff -u -r1.312 slime.el
--- slime.el	10 Jun 2004 17:34:07 -0000	1.312
+++ slime.el	15 Jun 2004 02:34:12 -0000
@@ -2586,7 +2589,8 @@
   (interactive)
   (unless (eq major-mode 'lisp-mode)
     (error "Only valid in lisp-mode"))
-  (save-some-buffers)
+  (lexical-let ((buffer (current-buffer)))
+    (save-some-buffers nil (lambda () (eq (current-buffer) buffer))))
   (let ((lisp-filename (slime-to-lisp-filename (buffer-file-name))))
     (slime-insert-transcript-delimiter
      (format "Compile file %s" lisp-filename))